﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using SystemComponent;

namespace eight_eight
{
    class queueObject
    {
        #region properties

        private int[,] matrix = new int[3, 3];
        private int manhatan = 0;
        private int emptyX, emptyY;
        private int gx = 0;
        private int hx = 0;
        public ArrayList path = new ArrayList();
        
        public int Manhatan
        {
            get { return manhatan; }
            set { manhatan = value; }
        }
        
        public int EmptyX
        {
            get { return emptyX; }
            set { emptyX = value; }
        }

        public int EmptyY
        {
            get { return emptyY; }
            set { emptyY = value; }
        }

        public int Gx
        {
            get { return gx; }
            set { gx = value; }
        }

        public int Hx
        {
            get
            {
                hx = manhatan + gx;
                return hx;
            }
        }

        public int[,] Matrix
        {
            get { return matrix; }
            set
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j < 3; j++)
                    {
                        matrix[i, j] = value[i, j];
                    }
                }
            }
        }

        #endregion

        public queueObject()
        {
        }
    }

    class priorityQueue
    {
        
        ArrayList queue = new ArrayList();
        bool up_down;
        private firstModel firstM;

        public firstModel FirstM 
        {
            set { firstM = value;}
        }

        public priorityQueue(bool up)
        {
            up_down = up;
        }

        public int getCount()
        {
            return queue.Count;
        }

        private int findIndex(int prt)
        {
            int count = queue.Count;
            int index = 0;
            for (int i = 0; i < count; i++)
            {
                if (up_down)
                {
                    if (((queueObject)queue[i]).Manhatan <= prt)
                    {
                        index++;
                        continue;
                    }
                }
                else
                {
                    if (((queueObject)queue[i]).Manhatan >= prt)
                    {
                        index++;
                        continue;
                    }
                }
            }
            return index;
        }

        public void enqueue(queueObject obj)
        {
            int count = queue.Count;
            int index = 0;
            bool state = false;
            //********* for check to not equal **************
            for (int j = 0; j < count; j++)
            {
                if (isEqual((queueObject)queue[j] ,obj))
                {
                    state = true;
                    break;
                }
            }
            //******* if not equal enqueu obj **************
            if (!state)
            {
                if (queue.Count == 0)
                {
                    queue.Add(obj);
                }
                else
                {
                    index = findIndex(obj.Manhatan + obj.Gx);
                    if (index >= count)
                    {
                        queue.Add(obj);
                    }
                    else
                    {
                        queue.Insert(index, obj);
                    }
                }
            }
        }

        public queueObject dequeue()
        {
            queueObject obj = new queueObject();
            queueObject obj2 = new queueObject();
            if (queue.Count > 0)
            {
                obj = (queueObject)queue[0];
                obj2.EmptyX = obj.EmptyX;
                obj2.EmptyY = obj.EmptyY;
                obj2.Manhatan = 1000;
                obj2.Matrix=obj.Matrix;
                queue.RemoveAt(0);
                queue.Add(obj2);
            }
            return obj;
        }

        public bool isEqual(queueObject ofList, queueObject forCheck)
        {
            return firstM.check(ofList.Matrix, forCheck.Matrix);
        }
    }
}
